IntegerProperty (JavaFX 28)
Description: declaration: module: javafx.base, package: javafx.beans.property, class: IntegerProperty

# Class IntegerProperty

java.lang.Object
javafx.beans.binding.NumberExpressionBase
javafx.beans.binding.IntegerExpression
javafx.beans.property.ReadOnlyIntegerProperty
javafx.beans.property.IntegerProperty

All Implemented Interfaces:
  `NumberExpression, Observable, Property<Number>, ReadOnlyProperty<Number>, ObservableIntegerValue, ObservableNumberValue, ObservableValue<Number>, WritableIntegerValue, WritableNumberValue, WritableValue<Number>`

Direct Known Subclasses:
  `IntegerPropertyBase, JavaBeanIntegerProperty`

public abstract class IntegerProperty extends ReadOnlyIntegerProperty implements Property<Number>, WritableIntegerValue
This class defines a `Property` wrapping an `int` value.

The value of an `IntegerProperty` can be get and set with `ObservableIntegerValue.get()`, `IntegerExpression.getValue()`, `WritableIntegerValue.set(int)`, and `setValue(Number)`.

A property can be bound and unbound unidirectional with `Property.bind(ObservableValue)` and `Property.unbind()`. Bidirectional bindings can be created and removed with `bindBidirectional(Property)` and `unbindBidirectional(Property)`.

The context of a `IntegerProperty` can be read with `ReadOnlyProperty.getBean()` and `ReadOnlyProperty.getName()`.

Note: setting or binding this property to a null value will set the property to "0.0". See `setValue(java.lang.Number)`.

Since:
  JavaFX 2.0
See Also:
  - `ObservableIntegerValue`
  - `WritableIntegerValue`
  - `ReadOnlyIntegerProperty`
  - `Property`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IntegerProperty()`
  Creates a default `IntegerProperty`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `ObjectProperty<Integer>`
  `asObject()`
  Creates an `ObjectProperty` that bidirectionally bound to this `IntegerProperty`.
  `void`
  `bindBidirectional(Property<Number> other)`
  Create a bidirectional binding between this `Property` and another one.
  `static IntegerProperty`
  `integerProperty(Property<Integer> property)`
  Returns a `IntegerProperty` that wraps a `Property` and is bidirectionally bound to it.
  `void`
  `setValue(Number v)`
  Set the wrapped value.
  `String`
  `toString()`
  Returns a string representation of this `IntegerProperty` object.
  `void`
  `unbindBidirectional(Property<Number> other)`
  Removes a bidirectional binding between this `Property` and another one.

  ### Methods declared in class ReadOnlyIntegerProperty

  `readOnlyIntegerProperty`

  ### Methods declared in class IntegerExpression

  `add, add, add, add, divide, divide, divide, divide, doubleValue, floatValue, getValue, integerExpression, integerExpression, intValue, longValue, multiply, multiply, multiply, multiply, negate, subtract, subtract, subtract, subtract`

  ### Methods declared in class NumberExpressionBase

  `add, asString, asString, asString, divide, greaterThan, greaterThan, greaterThan, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, greaterThanOrEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, isNotEqualTo, lessThan, lessThan, lessThan, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, lessThanOrEqualTo, multiply, numberExpression, subtract`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface Observable

  `addListener, removeListener, subscribe`

  ### Methods declared in interface ObservableIntegerValue

  `get`

  ### Methods declared in interface ObservableValue

  `addListener, flatMap, getValue, map, orElse, removeListener, subscribe, subscribe, when`

  ### Methods declared in interface Property

  `bind, isBound, unbind`

  ### Methods declared in interface ReadOnlyProperty

  `getBean, getName`

  ### Methods declared in interface WritableIntegerValue

  `get, set`

  ### Methods declared in interface WritableValue

  `getValue`

- ## Constructor Details

  - ### IntegerProperty

    public IntegerProperty()
    Creates a default `IntegerProperty`.

- ## Method Details

  - ### setValue

    public void setValue(Number v)
    Set the wrapped value.
    Specified by:
      `setValue` in interface `WritableIntegerValue`
    Specified by:
      `setValue` in interface `WritableValue<Number>`
    Parameters:
      `v` - The new value

  - ### bindBidirectional

    public void bindBidirectional(Property<Number> other)
    Create a bidirectional binding between this `Property` and another one. Bidirectional bindings exists independently of unidirectional bindings. So it is possible to add unidirectional binding to a property with bidirectional binding and vice-versa. However, this practice is discouraged.

    It is possible to have multiple bidirectional bindings of one Property.

    JavaFX bidirectional binding implementation use weak listeners. This means bidirectional binding does not prevent properties from being garbage collected.

    Specified by:
      `bindBidirectional` in interface `Property<Number>`
    Parameters:
      `other` - the other `Property`

  - ### unbindBidirectional

    public void unbindBidirectional(Property<Number> other)
    Removes a bidirectional binding between this `Property` and another one. If no bidirectional binding between the properties exists, calling this method has no effect. It is possible to unbind by a call on the second property. This code will work:

    >         property1.bindBidirectional(property2);
    >         property2.unbindBidirectional(property1);

    Specified by:
      `unbindBidirectional` in interface `Property<Number>`
    Parameters:
      `other` - the other `Property`

  - ### toString

    public String toString()
    Returns a string representation of this `IntegerProperty` object.
    Overrides:
      `toString` in class `ReadOnlyIntegerProperty`
    Returns:
      a string representation of this `IntegerProperty` object.

  - ### integerProperty

    public static IntegerProperty integerProperty(Property<Integer> property)
    Returns a `IntegerProperty` that wraps a `Property` and is bidirectionally bound to it. Changing this property will result in a change of the original property.

    This is very useful when bidirectionally binding an ObjectProperty<Integer> and a IntegerProperty.

    >       IntegerProperty integerProperty = new SimpleIntegerProperty(1);
    >       ObjectProperty<Integer> objectProperty = new SimpleObjectProperty<>(2);

    >       // Need to keep the reference as bidirectional binding uses weak references
    >       IntegerProperty objectAsInteger = IntegerProperty.integerProperty(objectProperty);

    >       integerProperty.bindBidirectional(objectAsInteger);

    Another approach is to convert the IntegerProperty to ObjectProperty using `asObject()` method.

    Note: null values in the source property will be interpreted as 0

    Parameters:
      `property` - The source `Property`
    Returns:
      A `IntegerProperty` that wraps the `Property`
    Throws:
      `NullPointerException` - if `property` is `null`
    Since:
      JavaFX 8.0
    See Also:
      - `asObject()`

  - ### asObject

    public ObjectProperty<Integer> asObject()
    Creates an `ObjectProperty` that bidirectionally bound to this `IntegerProperty`. If the value of this `IntegerProperty` changes, the value of the `ObjectProperty` will be updated automatically and vice-versa.

    Can be used for binding an ObjectProperty to IntegerProperty.

    >       IntegerProperty integerProperty = new SimpleIntegerProperty(1);
    >       ObjectProperty<Integer> objectProperty = new SimpleObjectProperty<>(2);

    >       objectProperty.bind(integerProperty.asObject());

    Overrides:
      `asObject` in class `ReadOnlyIntegerProperty`
    Returns:
      the new `ObjectProperty`
    Since:
      JavaFX 8.0